#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <queue>
using namespace std;

#define MAXSIZE 1010

int n,m;
int bestStep=-1;
bool map[MAXSIZE][MAXSIZE];
bool was[MAXSIZE][MAXSIZE];

struct point
{
    int x;
    int y;
    int steps;
    point (int newX,int newY,int newSteps);
};
point::point(int newX,int newY,int newSteps)
{
    x=newX;
    y=newY;
    steps=newSteps;
}
queue<point> points;

void initData()
{
    bestStep=-1;
    for(int i=0;i<MAXSIZE;i++)
        for(int j=0;j<MAXSIZE;j++)
        {
            map[i][j]=true;
            was[i][j]=false;
        }
}
bool cameOut(point cur)
{
    if(cur.x>0 && cur.x<=n && cur.y>0 && cur.y<=m)
        return false;
    if(bestStep==-1)
        bestStep=cur.steps;
    if(bestStep>cur.steps)
        bestStep=cur.steps;
    return true;
}
void addNeighbours(point cur)
{
    int deltaY;
    points.push(point(cur.x,cur.y-1,cur.steps+1));
    points.push(point(cur.x,cur.y+1,cur.steps+1));
    if(cur.x%2)
        deltaY=-1;
    else
        deltaY=1;
    points.push(point(cur.x-1,cur.y+deltaY,cur.steps+1));
    points.push(point(cur.x-1,cur.y,cur.steps+1));
    points.push(point(cur.x+1,cur.y+deltaY,cur.steps+1));
    points.push(point(cur.x+1,cur.y,cur.steps+1));
}
bool makeSteps(point cur)
{
    if(was[cur.x][cur.y]==true)
        return false;
    if(was[cur.x][cur.y]==false)
        was[cur.x][cur.y]=true;
    if(map[cur.x][cur.y]==false)
        return false;
    if(cameOut(cur))
        return true;
    addNeighbours(cur);
    return false;
}
void solve(int startX,int startY)
{
    point newPoint(startX,startY,0);
    points.push(newPoint);
    while(points.size())
    {
        newPoint=points.front();
        points.pop();
        if(makeSteps(newPoint))
        {
            while(points.size())
                points.pop();
            return;
        }
    }
}

int main()
{
#ifndef ONLINE_JUDGE
    freopen("game.in", "rt", stdin);
    //freopen("myGame.out.txt", "wt", stdout);
#endif
    char curStr[MAXSIZE];
    int testCount;
    int startX,startY;
    cin >> testCount;
    for(int i=0;i<testCount;i++)
    {
        cin >> n >> m;
        cin >> startX >> startY;
        initData();
        for(int j=1;j<=n;j++)
        {
            cin >> curStr;
            for(int k=1;k<=m;k++)
                map[j][k]=(curStr[k-1]=='1');
        }
        solve(startX,startY);
        if(bestStep==-1)
            cout << "No solution" << endl;
        else
            cout << bestStep << endl;
    }
    return 0;
}
